MovieClip.prototype.emptyClip = function(name, xPos, yPos, depth)
{
   var _loc1_ = this.createEmptyMovieClip(name,depth);
   _loc1_._x = xPos;
   _loc1_._y = yPos;
   return _loc1_;
};
Color.prototype.setTint = function(r, g, b, amount)
{
   var _loc1_ = new Object();
   _loc1_.ra = _loc1_.ga = _loc1_.ba = 100 - amount;
   var _loc2_ = amount / 100;
   _loc1_.rb = r * _loc2_;
   _loc1_.gb = g * _loc2_;
   _loc1_.bb = b * _loc2_;
   this.setTransform(_loc1_);
};
Color.prototype.setBrightness = function(bright)
{
   var _loc3_ = bright;
   var _loc2_ = 0;
   if(_loc3_ > 0)
   {
      _loc2_ = 256 * (_loc3_ / 100);
   }
   var _loc1_ = new Object();
   _loc1_.ra = _loc1_.ga = _loc1_.ba = 100 - Math.abs(_loc3_);
   _loc1_.rb = _loc1_.gb = _loc1_.bb = _loc2_;
   this.setTransform(_loc1_);
};
Color.prototype.setFlash = function()
{
   var _loc1_ = new Object();
   _loc1_.ra = _loc1_.ga = _loc1_.ba = 100;
   _loc1_.rb = _loc1_.gb = _loc1_.bb = 256;
   this.setTransform(_loc1_);
};
Color.prototype.setTintOffset = function(r, g, b)
{
   var _loc1_ = {rb:r,gb:g,bb:b};
   this.setTransform(_loc1_);
};
Color.prototype.setBrightOffset = function(offset)
{
   var _loc1_ = new Object();
   _loc1_.rb = _loc1_.gb = _loc1_.bb = offset;
   this.setTransform(_loc1_);
};
Color.prototype.negative = function()
{
   var _loc1_ = {ra:-100,ga:-100,ba:-100,rb:255,gb:255,bb:255};
   this.setTransform(_loc1_);
};
Color.prototype.reset = function()
{
   var _loc1_ = {ra:100,ga:100,ba:100,rb:0,gb:0,bb:0};
   this.setTransform(_loc1_);
};
MovieClip.prototype.distance = function(mc1, mc2)
{
   var _loc2_ = mc2._x - mc1._x;
   var _loc1_ = mc2._y - mc1._y;
   return int(Math.sqrt(_loc2_ * _loc2_ + _loc1_ * _loc1_) / 2);
};
MovieClip.prototype.getTopDepth = function(mcToCheck)
{
   var _loc3_ = mcToCheck;
   var _loc2_ = undefined;
   var d;
   var _loc1_ = 0;
   for(_loc1_ in _loc3_)
   {
      _loc2_ = _loc3_[_loc1_];
      if(_loc2_._name == _loc1_ & typeof _loc2_.getDepth === "function" & _loc2_._parent === _loc3_)
      {
         d = _loc3_[_loc1_].getDepth() + 1;
         if(d < 1)
         {
            return 1;
         }
         return d;
      }
   }
   return 1;
};
Math.easeOutCubic = function(t, b, c, d)
{
   var _loc1_ = t;
   return c * ((_loc1_ = _loc1_ / d - 1) * _loc1_ * _loc1_ + 1) + b;
};
MovieClip.prototype.textPlotter = function(setupObject)
{
   if(setupObject.globalSettings != undefined)
   {
      if(setupObject.globalSettings.container == undefined or setupObject.globalSettings.container == null or setupObject.targetName != undefined)
      {
         if(setupObject.targetName == undefined)
         {
            var con = setupObject.globalSettings.targetName.createEmptyMovieClip("textHolder",getTopDepth(setupObject.globalSettings.targetName));
         }
         else
         {
            var con = setupObject.targetName;
         }
         setupObject.globalSettings.container = con;
      }
      else
      {
         var con = setupObject.globalSettings.container;
      }
      if(setupObject.alpha != undefined)
      {
         var alpha = setupObject.alpha;
      }
      else if(setupObject.globalSettings.alpha != undefined)
      {
         var alpha = setupObject.globalSettings.alpha;
      }
      else
      {
         var alpha = 100;
      }
      if(setupObject.xPos == undefined)
      {
         if(setupObject.formatting != undefined)
         {
            var formatting = setupObject.formatting;
         }
         else if(setupObject.globalSettings.formatting != undefined)
         {
            var formatting = setupObject.globalSettings.formatting;
         }
      }
      if(setupObject.globalSettings.colourWash != undefined)
      {
         var colourWash = setupObject.globalSettings.colourWash;
      }
      if(setupObject.stageWidth != undefined)
      {
         var stageWidth = setupObject.stageWidth;
      }
      else if(setupObject.globalSettings.stageWidth != undefined)
      {
         var stageWidth = setupObject.globalSettings.stageWidth;
      }
      else
      {
         var stageWidth = 550;
      }
      if(setupObject.space != undefined)
      {
         var spaceWidth = setupObject.space;
      }
      else if(setupObject.globalSettings.space != undefined)
      {
         var spaceWidth = setupObject.globalSettings.space;
      }
      else
      {
         var spaceWidth = 0;
      }
      if(setupObject.globalSettings.lang != undefined)
      {
         var lang = setupObject.globalSettings.lang;
      }
      else
      {
         var lang = 0;
      }
      if(setupObject.buttonFlag != undefined)
      {
         var buttonFlag = true;
      }
      else if(setupObject.globalSettings.buttonFlag != undefined)
      {
         var buttonFlag = true;
      }
      else
      {
         var buttonFlag = false;
      }
   }
   if(setupObject.globalSettings.fontName != undefined)
   {
      var fontName = setupObject.globalSettings.fontName;
   }
   else if(setupObject.fontName != undefined)
   {
      var fontName = setupObject.fontName;
   }
   else
   {
      var fontName = "mcFont";
   }
   var depth = getTopDepth(con);
   if(colourWash == true)
   {
      depth++;
   }
   var _loc2_ = con.createEmptyMovieClip("textLine" + depth,depth);
   _loc2_._y = setupObject.yPos;
   _loc2_._alpha = alpha;
   var stringTxt = setupObject.string.toString();
   var c = stringTxt.length + 1;
   var gutter = 0;
   var _loc3_ = 0;
   var char;
   var _loc1_ = undefined;
   while(--c > 0)
   {
      char = stringTxt.charCodeAt(_loc3_) - 32;
      if(!char)
      {
         if(spaceWidth != 0)
         {
            gutter += spaceWidth;
         }
         else if(lang != 0)
         {
            _loc1_ = _loc2_.attachMovie(fontName,"char" + _loc3_,_loc3_);
            _loc1_._x = gutter;
            _loc1_.gotoAndStop(char + 1);
            _loc1_._xscale = 50;
            gutter += _loc1_._width;
         }
         else
         {
            _loc1_ = _loc2_.attachMovie(fontName,"char" + _loc3_,_loc3_);
            _loc1_._x = gutter;
            _loc1_.gotoAndStop(char + 1);
            gutter += _loc1_._width;
         }
      }
      else
      {
         _loc1_ = _loc2_.attachMovie(fontName,"char" + _loc3_,_loc3_);
         _loc1_._x = gutter;
         _loc1_.gotoAndStop(char + 1);
         gutter += _loc1_._width - 5;
      }
      _loc3_ = _loc3_ + 1;
   }
   if(setupObject.double == true)
   {
      _loc2_._xscale = _loc2_._yscale = 200;
   }
   if(formatting == "Justify")
   {
      _loc2_._x = stageWidth / 2 - _loc2_._width / 2;
   }
   else
   {
      _loc2_._x = setupObject.xPos;
   }
   if(setupObject.easing != undefined)
   {
      _loc2_.startPos = setupObject.easing.startPos;
      _loc2_.frames = setupObject.easing.frames;
      _loc2_.currentCnt = 0;
      _loc2_.change = _loc2_._x - _loc2_.startPos;
      _loc2_._x = _loc2_.startPos;
      _loc2_.onEnterFrame = function()
      {
         var _loc1_ = this;
         _loc1_._x = Math.easeOutCubic(_loc1_.currentCnt,_loc1_.startPos,_loc1_.change,_loc1_.frames);
         if(++_loc1_.currentCnt == _loc1_.frames)
         {
            delete _loc1_.onEnterFrame;
         }
      };
   }
   if(buttonFlag == true)
   {
      var hA = _loc2_.createEmptyMovieClip("hitArea",getTopDepth(_loc2_));
      var hAHeight = _loc2_._height - 1;
      hA.lineStyle(1,0,0);
      hA.beginFill(0,0);
      hA.moveTo(1,1);
      hA.lineTo(_loc2_._width - 1,1);
      hA.lineTo(_loc2_._width - 1,hAHeight);
      hA.lineTo(1,hAHeight);
      hA.lineTo(1,1);
      hA.endFill();
      hA._visible = false;
   }
   if(colourWash == true)
   {
      depth--;
      var cw = con.createEmptyMovieClip("cwBox" + depth,depth);
      _loc2_.cwMC = cw;
      cw._y = _loc2_._y;
      cw._x = _loc2_._x;
      var filltype = "linear";
      var colours = setupObject.colours;
      var numberOfColours = colours.length;
      var alphas = new Array(numberOfColours);
      var ratios = new Array(numberOfColours);
      var average = int(255 / (numberOfColours - 1));
      var curAverage = 0;
      var cnt = -1;
      while(++cnt != numberOfColours)
      {
         alphas[cnt] = 100;
         ratios[cnt] = curAverage;
         curAverage += average;
      }
      var matrix = {matrixType:"box",x:0,y:0,w:_loc2_._width,h:_loc2_._height,r:1.5707963267949};
      var cwHeight = _loc2_._height - 1;
      cw.lineStyle(1,0);
      cw.beginGradientFill(filltype,colours,alphas,ratios,matrix);
      cw.moveTo(1,1);
      cw.lineTo(_loc2_._width - 1,1);
      cw.lineTo(_loc2_._width - 1,cwHeight);
      cw.lineTo(1,cwHeight);
      cw.lineTo(1,1);
      cw.endFill();
   }
   return _loc2_;
};
Color.prototype.negative = function()
{
   var _loc1_ = {ra:-100,ga:-100,ba:-100,rb:255,gb:255,bb:255};
   this.setTransform(_loc1_);
};
Color.prototype.colorDodge = function(r, g, b)
{
   var _loc1_ = new Object();
   _loc1_.ra = 100 / ((258 - r) / 256);
   _loc1_.ga = 100 / ((258 - g) / 256);
   _loc1_.ba = 100 / ((258 - b) / 256);
   this.setTransform(_loc1_);
};
Color.prototype.linearDodge = function(r, g, b)
{
   var _loc1_ = new Object();
   _loc1_.rb = r;
   _loc1_.gb = g;
   _loc1_.bb = b;
   this.setTransform(_loc1_);
};
Color.prototype.linearBurn = function(r, g, b)
{
   var _loc1_ = new Object();
   _loc1_.rb = r - 255;
   _loc1_.gb = g - 255;
   _loc1_.bb = b - 255;
   this.setTransform(_loc1_);
};
Color.prototype.screen = function(r, g, b)
{
   var _loc1_ = new Object();
   _loc1_.rb = r;
   _loc1_.ra = 100 * (255 - r) / 255;
   _loc1_.gb = g;
   _loc1_.ga = 100 * (255 - g) / 255;
   _loc1_.bb = b;
   _loc1_.ba = 100 * (255 - b) / 255;
   this.setTransform(_loc1_);
};
_global.textPlotterGlobal = {targetName:_root.attractMode.txtHolder,stageWidth:600,space:8,formatting:"Justify"};
MovieClip.prototype.curvePlotter = function(startPosition, middlePosition, finalPosition, speed)
{
   var q1x = startPosition.x;
   var q1y = startPosition.y;
   var q2x = middlePosition.x;
   var q2y = middlePosition.y;
   var q3x = finalPosition.x;
   var q3y = finalPosition.y;
   var _loc1_ = 0;
   var _loc2_ = undefined;
   var t1;
   var t2;
   var _loc3_ = undefined;
   this.coords = new Array();
   while(_loc1_ < 1)
   {
      _loc2_ = 1 - _loc1_;
      t1 = _loc2_ * _loc2_;
      t2 = 2 * _loc1_ * _loc2_;
      _loc3_ = _loc1_ * _loc1_;
      this.coords.push(int(t1 * q1x + t2 * q2x + _loc3_ * q3x));
      this.coords.push(int(t1 * q1y + t2 * q2y + _loc3_ * q3y));
      _loc1_ += speed;
   }
};
